Index: code/branches/mergeFS18/src/libraries/network/Client.cc
===================================================================
--- code/branches/mergeFS18/src/libraries/network/Client.cc	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/Client.cc	(revision 12027)
@@ -166,15 +166,8 @@
           }
         }
-        //assert(gs); <--- there might be the case that no data has to be sent, so its commented out now
-//         if(gs){
-//           orxout(verbose, context::network) << "client tick: sending gs " << gs << endl;
-//           if( !gs->send() )
-//             orxout(internal_warning, context::network) << "Problem adding partial gamestate to queue" << endl;
-//         // gs gets automatically deleted by enet callback
-//         }
+
         FunctionCallManager::sendCalls(static_cast<Host*>(this));
       }
     }
-//     sendPackets(); // flush the enet queue
 
     Connection::processQueue();
@@ -185,6 +178,5 @@
         isSynched_=true;
     }
-//     GamestateManager::cleanup();;
-//     Connection::sendPackets();
+
 
     return;
Index: code/branches/mergeFS18/src/libraries/network/ClientConnection.cc
===================================================================
--- code/branches/mergeFS18/src/libraries/network/ClientConnection.cc	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/ClientConnection.cc	(revision 12027)
@@ -105,6 +105,6 @@
       {
         // manually add server to list of peers
-        /*incomingEvent inEvent = */Connection::preprocessConnectEvent(event);
-//         addPeer(inEvent.peerID);
+        Connection::preprocessConnectEvent(event);
+
         // start communication thread
         this->established_=true;
@@ -155,5 +155,4 @@
     assert( this->server_ );
     assert( packet );
-//     return Connection::addPacket( packet, NETWORK_PEER_ID_SERVER, channelID );
     // HACK: actually there should be a way to do this using addPacket and the correct peerID
     return Connection::broadcastPacket(packet, channelID);
@@ -168,5 +167,5 @@
     this->established_=false;
     orxout(internal_error, context::network) << "Received disconnect Packet from Server!" << endl;
-        // server closed the connection
+    // server closed the connection
     this->stopCommunicationThread();
     this->connectionClosed();
Index: code/branches/mergeFS18/src/libraries/network/ClientConnection.h
===================================================================
--- code/branches/mergeFS18/src/libraries/network/ClientConnection.h	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/ClientConnection.h	(revision 12027)
@@ -36,5 +36,5 @@
 {
 
-  class _NetworkExport ClientConnection: public Connection{
+  class _NetworkExport ClientConnection: public Connection {
   public:
     ClientConnection();
@@ -44,7 +44,4 @@
     void setPort( unsigned int port );
 
-//     ENetEvent *getEvent();
-    // check wheter the packet queue is empty
-//     bool queueEmpty();
     // create a new listener thread
     virtual bool establishConnection();
Index: code/branches/mergeFS18/src/libraries/network/ClientConnectionListener.cc
===================================================================
--- code/branches/mergeFS18/src/libraries/network/ClientConnectionListener.cc	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/ClientConnectionListener.cc	(revision 12027)
@@ -31,5 +31,4 @@
 #include "core/CoreIncludes.h"
 #include "core/GameMode.h"
-// #include "ClientInformation.h"
 
 namespace orxonox
@@ -37,4 +36,8 @@
     RegisterAbstractClass(ClientConnectionListener).inheritsFrom<Listable>();
 
+    /**
+     * Constructor
+     * Register the object
+     */
     ClientConnectionListener::ClientConnectionListener()
     {
@@ -42,4 +45,8 @@
     }
 
+    /**
+     * Call clientConnected() on all ClientConnectionListeners.
+     * @param clientID The ID of the newly connected client
+     */
     void ClientConnectionListener::broadcastClientConnected(unsigned int clientID)
     {
@@ -48,4 +55,8 @@
     }
 
+    /**
+     * Call clientDisconnected() on all ClientConnectionListeners.
+     * @param clientID The ID of the newly disconnected client
+     */
     void ClientConnectionListener::broadcastClientDisconnected(unsigned int clientID)
     {
@@ -53,14 +64,4 @@
             listener->clientDisconnected(clientID);
     }
-
-//     void ClientConnectionListener::getConnectedClients()
-//     {
-//         ClientInformation* client = ClientInformation::getBegin();
-//         while (client)
-//         {
-//             this->clientConnected(client->getID());
-//             client = client->next();
-//         }
-//     }
 }
 
Index: code/branches/mergeFS18/src/libraries/network/ClientConnectionListener.h
===================================================================
--- code/branches/mergeFS18/src/libraries/network/ClientConnectionListener.h	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/ClientConnectionListener.h	(revision 12027)
@@ -35,4 +35,7 @@
 namespace orxonox
 {
+    /**
+     * An abstract base class. Derived classes must implement clientConnected() and clientDisconnected().
+     */
     class _NetworkExport ClientConnectionListener : virtual public Listable
     {
@@ -46,7 +49,4 @@
             virtual void clientConnected(unsigned int clientID) = 0;
             virtual void clientDisconnected(unsigned int clientID) = 0;
-
-        protected:
-//             void getConnectedClients();
     };
 }
Index: code/branches/mergeFS18/src/libraries/network/Connection.cc
===================================================================
--- code/branches/mergeFS18/src/libraries/network/Connection.cc	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/Connection.cc	(revision 12027)
@@ -38,4 +38,5 @@
 
 #include "packet/Packet.h"
+#include "util/Output.h"
 #include <util/Sleep.h>
 
@@ -45,20 +46,35 @@
   const unsigned int                NETWORK_DISCONNECT_TIMEOUT = 500;
 
+  /**
+   * Constructor
+   * @param firstPeerId The initial value of nextPeerID_
+   */
   Connection::Connection(uint32_t firstPeerID):
     host_(nullptr), bCommunicationThreadRunning_(false), nextPeerID_(firstPeerID)
   {
+    // Global initialization of ENet
     enet_initialize();
+
+    // Register enet_deinitialize to be executed when the program exits normally
     atexit(enet_deinitialize);
+
+    // Create mutexes for incoming and outgoing events
     this->incomingEventsMutex_ = new boost::mutex;
     this->outgoingEventsMutex_ = new boost::mutex;
-//     this->overallMutex_ = new boost::mutex;
-  }
-
+  }
+
+  /**
+   * Destructor
+   */
   Connection::~Connection()
   {
+    // Delete the mutexes
     delete this->incomingEventsMutex_;
     delete this->outgoingEventsMutex_;
   }
 
+  /**
+   * Start the main communication thread.
+   */
   void Connection::startCommunicationThread()
   {
@@ -67,10 +83,14 @@
   }
   
+  /**
+   * Stop the main communication thread.
+   */
   void Connection::stopCommunicationThread()
   {
     this->bCommunicationThreadRunning_ = false;
-    if( !this->communicationThread_->timed_join(NETWORK_COMMUNICATION_THREAD_WAIT_TIME) )
-    {
-      // force thread to stop
+    // Wait for peaceful termination
+    if(!this->communicationThread_->timed_join(NETWORK_COMMUNICATION_THREAD_WAIT_TIME))
+    {
+      // Force thread to stop if the waiting time runs out.
       this->communicationThread_->interrupt();
     }
@@ -78,7 +98,10 @@
   }
 
+  /**
+   * Send an outgoing event of type 'disconnectPeer'.
+   * @param peerID The peer to which the event is sent
+   */
   void Connection::disconnectPeer(uint32_t peerID)
   {
-//     this->overallMutex_->lock();
     outgoingEvent outEvent = { peerID, OutgoingEventType::disconnectPeer, nullptr, 0 };
     
@@ -86,7 +109,9 @@
     this->outgoingEvents_.push_back(outEvent);
     this->outgoingEventsMutex_->unlock();
-//     this->overallMutex_->unlock();
-  }
-  
+  }
+
+  /**
+   * Send an outgoing event of type 'disconnectPeers'.
+   */
   void Connection::disconnectPeers()
   {
@@ -98,7 +123,12 @@
   }
 
+  /**
+   * Send a packet.
+   * @param packet Pointer to the packet to send
+   * @param peerID The peer to which the event is sent
+   * @param channelId The channel ID
+   */
   void Connection::addPacket(ENetPacket* packet, uint32_t peerID, uint8_t channelID)
   {
-//     this->overallMutex_->lock();
     outgoingEvent outEvent = { peerID, OutgoingEventType::sendPacket, packet, channelID };
     
@@ -106,10 +136,13 @@
     this->outgoingEvents_.push_back(outEvent);
     this->outgoingEventsMutex_->unlock();
-//     this->overallMutex_->unlock();
-  }
-  
+  }
+  
+  /**
+   * Send a broadcast packet.
+   * @param packet Pointer to the packet to send
+   * @param channelId The channel ID
+   */
   void Connection::broadcastPacket(ENetPacket* packet, uint8_t channelID)
   {
-//     this->overallMutex_->lock();
     outgoingEvent outEvent = { 0, OutgoingEventType::broadcastPacket, packet, channelID };
     
@@ -117,24 +150,24 @@
     this->outgoingEvents_.push_back(outEvent);
     this->outgoingEventsMutex_->unlock();
-//     this->overallMutex_->unlock();
-  }
-
-  
+  }
+
+  
+  /**
+   * Main communication thread
+   */
   void Connection::communicationThread()
   {
     ENetEvent event;
     
-//     this->overallMutex_->lock();
-    while( bCommunicationThreadRunning_ )
+    while(this->bCommunicationThreadRunning_)
     {
       // Receive all pending incoming Events (such as packets, connects and disconnects)
-      while( enet_host_check_events( this->host_, &event ) > 0 )
+      while(enet_host_check_events(this->host_, &event ) > 0)
       {
-        processIncomingEvent(event);
+        this->processIncomingEvent(event);
       }
       
-//       this->overallMutex_->unlock();
+      // Sleep for 1ms
       msleep(1);
-//       this->overallMutex_->lock();
       
       // Send all waiting outgoing packets
@@ -142,7 +175,7 @@
       uint32_t outgoingEventsCount = this->outgoingEvents_.size();
       this->outgoingEventsMutex_->unlock();
-      while( outgoingEventsCount > 0 )
+
+      while(outgoingEventsCount > 0)
       {
-//         orxout(verbose, context::network) << "outgoing event" << endl;
         this->outgoingEventsMutex_->lock();
         outgoingEvent outEvent = this->outgoingEvents_.front();
@@ -150,5 +183,5 @@
         this->outgoingEventsMutex_->unlock();
         
-        processOutgoingEvent(outEvent);
+        this->processOutgoingEvent(outEvent);
         
         this->outgoingEventsMutex_->lock();
@@ -158,17 +191,20 @@
       
       // Wait for incoming events (at most NETWORK_WAIT_TIMEOUT ms)
-      if( enet_host_service( this->host_, &event, NETWORK_WAIT_TIMEOUT ) > 0 )
+      if(enet_host_service(this->host_, &event, NETWORK_WAIT_TIMEOUT) > 0)
       {
-        processIncomingEvent(event);
+        this->processIncomingEvent(event);
       }
     }
-//     this->overallMutex_->unlock();
-  }
-  
+  }
+  
+  /**
+   * Handle an incoming event.
+   * @param event The incoming event
+   */
   void Connection::processIncomingEvent(ENetEvent& event)
   {
     incomingEvent inEvent;
     // preprocess event
-    switch( event.type )
+    switch(event.type)
     {
       case ENET_EVENT_TYPE_CONNECT:
@@ -192,25 +228,29 @@
   }
   
+  /**
+   * Send an event.
+   * @param event The event to send
+   */
   void Connection::processOutgoingEvent(outgoingEvent& event)
   {
     ENetPeer* peer;
-    switch( event.type )
+    switch(event.type)
     {
       case OutgoingEventType::sendPacket:
         // check whether the peer is still/already in the peer list
-        if( this->peerMap_.find(event.peerID) != this->peerMap_.end() )
+        if(this->peerMap_.find(event.peerID) != this->peerMap_.end())
         {
           peer = this->peerMap_[event.peerID];
-          enet_peer_send( peer, event.channelID, event.packet );
+          enet_peer_send(peer, event.channelID, event.packet);
         }
         else
         {
           // peer probably already disconnected so just discard packet
-          assert(event.peerID<this->nextPeerID_);
+          orxout(message) << "Trying to send packet to peer that is not in peer list. Ignoring packet." << endl;
           enet_packet_destroy(event.packet);
         }
         break;
       case OutgoingEventType::disconnectPeer:
-        if( this->peerMap_.find(event.peerID) != this->peerMap_.end() )
+        if(this->peerMap_.find(event.peerID) != this->peerMap_.end())
         {
           peer = this->peerMap_[event.peerID];
@@ -220,9 +260,9 @@
         {
           // peer probably already disconnected so just discard disconnect event
-          assert(event.peerID<this->nextPeerID_);
+          assert(event.peerID < this->nextPeerID_);
         }
         break;
       case OutgoingEventType::disconnectPeers:
-        disconnectPeersInternal();
+        this->disconnectPeersInternal();
         break;
       case OutgoingEventType::broadcastPacket:
@@ -234,5 +274,4 @@
   }
 
-
   void Connection::disconnectPeersInternal()
   {
@@ -241,5 +280,5 @@
       enet_peer_disconnect(mapEntry.second, 0);
     }
-    uint32_t iterations = NETWORK_DISCONNECT_TIMEOUT/NETWORK_WAIT_TIMEOUT;
+    uint32_t iterations = NETWORK_DISCONNECT_TIMEOUT / NETWORK_WAIT_TIMEOUT;
     uint32_t i = 0;
     while( this->peerMap_.size() && i++ < iterations )
@@ -361,4 +400,3 @@
   }
 
-
 }
Index: code/branches/mergeFS18/src/libraries/network/Connection.h
===================================================================
--- code/branches/mergeFS18/src/libraries/network/Connection.h	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/Connection.h	(revision 12027)
@@ -96,5 +96,5 @@
 
   protected:
-    Connection(uint32_t firstPeerID = NETWORK_PEER_ID_SERVER+1);
+    Connection(uint32_t firstPeerID = NETWORK_PEER_ID_SERVER + 1);
     
     void startCommunicationThread();
@@ -110,7 +110,7 @@
     void processQueue();
     void waitOutgoingQueue();     // wait for the outgoing queue to become empty (everything processed by communication thread)
-    virtual void addPeer(uint32_t peerID)=0;
-    virtual void removePeer(uint32_t peerID)=0;
-    virtual void processPacket( packet::Packet* packet)=0;
+    virtual void addPeer(uint32_t peerID) = 0;
+    virtual void removePeer(uint32_t peerID) = 0;
+    virtual void processPacket( packet::Packet* packet) = 0;
     
     incomingEvent preprocessConnectEvent(ENetEvent& event);
@@ -124,4 +124,5 @@
 
     ENetHost*                     host_;
+
   private:
     void communicationThread();
@@ -130,6 +131,11 @@
     bool                          bCommunicationThreadRunning_;
     ENetAddress*                  bindAddress_;
+
+    // Queue for incoming events
     std::deque<incomingEvent>     incomingEvents_;
+
+    // Queue for outgoing events
     std::deque<outgoingEvent>     outgoingEvents_;
+
     boost::mutex*                 incomingEventsMutex_;
     boost::mutex*                 outgoingEventsMutex_;
Index: code/branches/mergeFS18/src/libraries/network/FunctionCallManager.cc
===================================================================
--- code/branches/mergeFS18/src/libraries/network/FunctionCallManager.cc	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/FunctionCallManager.cc	(revision 12027)
@@ -42,14 +42,20 @@
 void FunctionCallManager::addCall(uint32_t functionID, uint32_t objectID, uint32_t peerID, const MultiType& mt1, const MultiType& mt2, const MultiType& mt3, const MultiType& mt4, const MultiType& mt5)
 {
-  if(sPeerMap_.find(peerID)==sPeerMap_.end())
+  // If the peerID doesn't exist yet in the map...
+  if(sPeerMap_.find(peerID) == sPeerMap_.end())
   {
+    // ... add a new FunctionCalls packet for the peer
     FunctionCallManager::sPeerMap_[peerID] = new packet::FunctionCalls;
     FunctionCallManager::sPeerMap_[peerID]->setPeerID(peerID);
   }
+
+  // Add a new function call to the peer
   FunctionCallManager::sPeerMap_[peerID]->addCall(functionID, objectID, mt1, mt2, mt3, mt4, mt5);
 }
 
-// Send calls
-
+/**
+ * Send all function calls in sPeerMap_ to a given host, then clear sPeerMap_
+ * @param host The host to send the function calls to
+ */
 void FunctionCallManager::sendCalls(orxonox::Host* host)
 {
@@ -62,4 +68,7 @@
 }
 
+/**
+ * Place an incoming function call in the queue for processing.
+ */
 void FunctionCallManager::bufferIncomingFunctionCall(const orxonox::FunctionCall& fctCall, uint32_t minGamestateID, uint32_t peerID)
 {
@@ -67,8 +76,11 @@
 }
 
+/**
+ * Process queue of incoming function calls.
+ */
 void FunctionCallManager::processBufferedFunctionCalls()
 {
   std::vector<std::pair<FunctionCall, std::pair<uint32_t, uint32_t>>>::iterator it = FunctionCallManager::sIncomingFunctionCallBuffer_.begin();
-  while( it!=FunctionCallManager::sIncomingFunctionCallBuffer_.end() )
+  while( it != FunctionCallManager::sIncomingFunctionCallBuffer_.end() )
   {
     OrxAssert( Host::getActiveInstance(), "No Host class existing" );
Index: code/branches/mergeFS18/src/libraries/network/FunctionCallManager.h
===================================================================
--- code/branches/mergeFS18/src/libraries/network/FunctionCallManager.h	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/FunctionCallManager.h	(revision 12027)
@@ -53,6 +53,9 @@
   static void processBufferedFunctionCalls();
 
+  // Maps peer IDs to function calls
   static std::map<uint32_t, packet::FunctionCalls*>                           sPeerMap_;
+
   static std::vector<std::pair<FunctionCall,std::pair<uint32_t, uint32_t>>> sIncomingFunctionCallBuffer_;
+
 protected:
   FunctionCallManager();
Index: code/branches/mergeFS18/src/libraries/network/GamestateHandler.cc
===================================================================
--- code/branches/mergeFS18/src/libraries/network/GamestateHandler.cc	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/GamestateHandler.cc	(revision 12027)
@@ -32,6 +32,4 @@
 namespace orxonox {
 
-// GamestateHandler *GamestateHandler::instance_=nullptr;
-
 GamestateHandler::GamestateHandler()
 {
Index: code/branches/mergeFS18/src/libraries/network/GamestateHandler.h
===================================================================
--- code/branches/mergeFS18/src/libraries/network/GamestateHandler.h	(revision 12026)
+++ code/branches/mergeFS18/src/libraries/network/GamestateHandler.h	(revision 12027)
@@ -37,5 +37,6 @@
 
 /**
-    @author Oliver Scheuss
+ * An interface for any class that wants to handle gamestates.
+ * @author Oliver Scheuss
 */
 class _NetworkExport GamestateHandler
@@ -51,6 +52,6 @@
     virtual bool      addGamestate(packet::Gamestate* gs, unsigned int clientID) = 0;
     virtual bool      ackGamestate(unsigned int gamestateID, unsigned int clientID) = 0;
-    virtual uint32_t  getLastReceivedGamestateID( unsigned int clientID )=0;
-    virtual uint32_t  getCurrentGamestateID()=0;
+    virtual uint32_t  getLastReceivedGamestateID( unsigned int clientID ) = 0;
+    virtual uint32_t  getCurrentGamestateID() = 0;
 };
 
